package de.tu_darmstadt.tk.SmartHomeNetworkSim.core.devices;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.RoomStatus;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.SimulationManager;

public class SmartTemperatureSensor extends FloatSensorDevice implements SensorLabel {
	
	
	private RoomStatus roomStatus;

	
	public SmartTemperatureSensor(String name, RoomStatus room) {
		super(name, 1000);
		roomStatus = room;
		SimulationManager.scheduleEvent(this);
	}
	
	@Override
	public void simulateEvent(long time) {
		updateData();
		//Update again in 10 seconds
		nextSimulationTime=time + updateInterval;
		SimulationManager.scheduleEvent(this);
	}
	
	@Override
	protected void updateData() {
		/**
		 * Update Temperature to Room Temperature
		 */
		setFSval(roomStatus.getTemperature());
	}

	@Override
	public String getSensorLabel() {
		return "" + getFSval();
	}
	@Override
	public float getFSval() {
		return roomStatus.getTemperature();
	}
	
}
